INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('901002','900000','ACC','Lihat Proyek',2,true);

INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'NEW',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'ENB',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'OPN',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'UPD',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'DEL',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'PRN',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'VOI',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'CHK',true FROM obj WHERE objid='901002';
INSERT INTO OBJACL (objid, acstype, acsenable) SELECT objid,'APR',true FROM obj WHERE objid='901002';

INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'NEW', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'ENB', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'OPN', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'UPD', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'DEL', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'PRN', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'VOI', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'CHK', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('ADM', '901002', 'APR', TRUE, null);


INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'NEW', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'ENB', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'OPN', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'UPD', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'DEL', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'PRN', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'VOI', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'CHK', TRUE, null);
INSERT INTO GRPPRV (grpid, objid, acstype, acsenable, acsval) VALUES('KAS', '901002', 'APR', TRUE, null);DROP TYPE tPrjLabaRugi CASCADE;
CREATE TYPE tPrjLabaRugi AS (
	prjid      VARCHAR, 
	prjname    VARCHAR, 
	bpid       VARCHAR,
	bpname     VARCHAR,
	pendapatan	NUMERIC(19, 4),
	biaya	    NUMERIC(19, 4),
	lr	        NUMERIC(19, 4)
);

CREATE OR REPLACE FUNCTION flabarugiprj(_startdate date, _enddate date, _prjid character varying)
  RETURNS SETOF tPrjLabaRugi AS
$BODY$
DECLARE
	_retval		tPrjLabaRugi%ROWTYPE;
	_newPrjid   VARCHAR; 
	_prjname	VARCHAR;
	_bpid       VARCHAR;
	_bpname     VARCHAR;
	_pendapatan	NUMERIC(19, 4);
	_biaya	    NUMERIC(19, 4);
	_lr	        NUMERIC(19, 4);
	cPrj	    REFCURSOR;
BEGIN
	OPEN cPrj FOR
    	SELECT prjid, prjname, bp.bpid, bpname,
		(SELECT SUM(f.accbal) 
			FROM fLabaRugiFix1(_startdate, _enddate, null ,null ,null,null, _prjid) f 
			WHERE f.acctype1 = '400') AS pendapatan
		,
		(SELECT SUM(f.accbal) FROM fLabaRugiFix1(_startdate, _enddate, null ,null ,null,null, _prjid) f 
			WHERE f.acctype1 = '500') AS biaya FROM prj 
		LEFT JOIN bp ON prj.bpid = bp.bpid 
		WHERE prjid = _prjid;

	LOOP
		FETCH cPrj INTO _newPrjid, _prjname, _bpid, _bpname, _pendapatan, _biaya;
		EXIT WHEN NOT FOUND;
				_retval.prjid:=_newPrjid;
				_retval.prjname:=_prjname;
				_retval.bpid:=_bpid;
				_retval.bpname:=_bpname;
				_retval.pendapatan:=_pendapatan;
				_retval.biaya:=_biaya;
				_retval.lr:=_pendapatan - _biaya;
				RETURN NEXT _retval;
	END LOOP;
	CLOSE cPrj;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION flabarugiprj(date, date, character varying)
  OWNER TO bits;



CREATE OR REPLACE FUNCTION fmainlabarugiprj(_startdate date, _enddate date, _active boolean)
  RETURNS SETOF tPrjLabaRugi AS
$BODY$
DECLARE
	_retval		tPrjLabaRugi%ROWTYPE;
	_prjid   	VARCHAR; 
	_newPrjId 	VARCHAR;
	_prjname	VARCHAR;
	_bpid       VARCHAR;
	_bpname     VARCHAR;
	_pendapatan	NUMERIC(19, 4);
	_biaya	    NUMERIC(19, 4);
	_lr	        NUMERIC(19, 4);
	cPrj	    REFCURSOR;
BEGIN

	IF (_active IS NOT NULL) THEN
	    OPEN cPrj FOR
	    	SELECT DISTINCT prj.prjid FROM prj JOIN jnld ON jnld.prjid = prj.prjid WHERE prj.active = _active;
	    LOOP
			FETCH cPrj INTO _prjid;
			EXIT WHEN NOT FOUND;
					SELECT INTO _newPrjId, _prjname,_bpid, _bpname, _pendapatan, _biaya, _lr prjid, prjname, bpid, bpname, pendapatan, biaya, lr 
					FROM flabarugiprj(_startdate, _enddate, _prjid);
					_retval.prjid:=_newPrjId;
					_retval.prjname:=_prjname;
					_retval.bpid:=_bpid;
					_retval.bpname:=_bpname;
					_retval.biaya:=_biaya;
					_retval.pendapatan:=_pendapatan;
					_retval.lr:=_lr;
					RETURN NEXT _retval;
		END LOOP;
	ELSE 
		OPEN cPrj FOR
	    	SELECT DISTINCT prj.prjid FROM prj JOIN jnld ON jnld.prjid = prj.prjid;
	    LOOP
			FETCH cPrj INTO _prjid;
			EXIT WHEN NOT FOUND;
					SELECT INTO _newPrjId, _prjname,_bpid, _bpname, _pendapatan, _biaya, _lr prjid, prjname, bpid, bpname, pendapatan, biaya, lr 
					FROM flabarugiprj(_startdate, _enddate, _prjid);
					_retval.prjid:=_newPrjId;
					_retval.prjname:=_prjname;
					_retval.bpid:=_bpid;
					_retval.bpname:=_bpname;
					_retval.biaya:=_biaya;
					_retval.pendapatan:=_pendapatan;
					_retval.lr:=_lr;
					RETURN NEXT _retval;
		END LOOP;
	END IF;	
	CLOSE cPrj;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION fmainlabarugiprj(date, date, boolean)
  OWNER TO bits;

